poj 3126 Prime Path (BFS + 素数打表) poj 3126 (BFS + 素数打表)


                                     poj 3126 (BFS + 素数打表)

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0



题意:给你两个4位数,要求你每次只能变换一位数字,并且变换前后的数字都要满足是素数;求最少变换次数;

首先打好素数表,再进行BFS

代码:

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <queue>
using namespace std;

#define N 10100

int prime[N];

struct node //bfs记录步数
{
    int x,step;
};

void hint() // 打N以内素数表,prime[i] = 0 是素数
{
    memset(prime,0,sizeof(prime));
    prime[1] = 1;
    for(int i = 2; i < N; i++)
    {
        if(prime[i] == 0)
        {
            for(int j = 2; j*i < N; j++)
                prime[j*i] = 1;
        }
    }
}

int BFS(int s,int e)
{
    int vis[N],num; //vis用来标记是否查找过
    memset(vis,0,sizeof(vis));
    queue <node> p;//申请队列
    node st;
    st.x = s ;
    st.step = 0;
    vis[s] = 1;
    p.push(st);
    while(!p.empty())
    {
        node now = p.front();
        p.pop();
        if(now.x == e)//若找到终止值,返回步数
            return now.step;
        int t[5];
        t[1] = now.x/1000; // 千位数
        t[2] = (now.x/100)%10; // 百位数
        t[3] = (now.x/10)%10; // 十位数
        t[4] = now.x%10; //各位

        for(int i = 1; i <= 4 ; i++)
        {
            int temp = t[i];//这里特别注意,每次只能变换一位数,这里用来保存该变换位的数,变换下一位数时,该位数要恢复
            for(int j = 0 ; j < 10 ;j++)
            {
                node next = now;
                if(t[i]!=j)
                {
                    t[i]=j;
                    num = 1000*t[1]+100*t[2]+10*t[3]+t[4];
                }
                //判断是否满足
                if(num>1000 && num < 9999 && !vis[num] && !prime[num])
                {
                    next.x = num;
                    next.step++;
                    vis[num] = 1;
                    p.push(next);
                }
            }
            t[i] = temp; //恢复
        }
    }
    return -1;
}

int main()
{
    int n,a,b,ans;
    hint();
    scanf("%d",&n);
    while(n--)
    {
        scanf("%d%d",&a,&b);
        ans = BFS(a,b);
        if(ans != -1)
            printf("%d\n",ans);
        else
            printf("Impossible\n");

    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/Xuedan_blog/article/details/80749427